% Company: The Hong Kong Polytechnic University
% Engineer: Alexandr Melnikov
close all;
clear all;
clc;

set(0,'defaultaxesfontsize',16)
set(0,'defaultlinelinewidth',2)

% data to be transmitted
aa=0:1:255;
a=[aa aa aa aa]; % data to transmit

u=udp('192.168.1.10',58210,'LocalPort',50722); % udp object associated
% with remote host at 192.168.1.10 and remote port value 58210 - FPGA
% settings
set(u,'InputBufferSize',1024);  % Input buffer
set(u,'OutputBufferSize',1024); % Output buffer
set(u,'Timeout',1);             % Timeout
fopen(u);                       % Open port

% write data to echo-server and read it back
fwrite(u,a,'uint8');            % write data to echo-server
b=fread(u,length(a),'uint8');   % read back data from echo-server

% close port and delete object
fclose(u);
delete(u);
clear u;

% compare and display send vs received data
err=a-b';
figure(1)
subplot(2,1,1)
plot(a,'b');hold on;plot(b,'--r');axis tight
xlabel('Byte,n')
ylabel('Number')
legend('Tx','Rx')
title('Transmitted vs Received Data')
subplot(2,1,2)
plot(err);axis tight
xlabel('Byte,n')
ylabel('Error')
title('Error between Tx and Rx Data')
